/*

 File generated by ../../tools/trash_process_config.py from trash_process_config.input

 Copyright (c) 2010 Fizians SAS. <http://www.fizians.com>
 This file is part of Rozofs.

 Rozofs is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published
 by the Free Software Foundation, version 2.

 Rozofs is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see
 <http://www.gnu.org/licenses/>.
 */
#ifndef _TRASH_PROCESS_CONFIG_H
#define _TRASH_PROCESS_CONFIG_H

#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <errno.h>
#include <libconfig.h>
#include <unistd.h>
#include <inttypes.h>
#include <sys/types.h>
#include <dirent.h>
void trash_process_config_read(char * fname);


/*_______________________________
** ENUM definion
*/

/*_______________________________
** trash_process_config structure
*/
typedef struct _trash_process_config_t {

  /*
  ** global scope configuration parameters
  */

  // This option defines the scanning frequency in hours of the trash 
  // process.
  // See the --frequency parameter of the CLI.
  int32_t     frequency;
  // Exclude files that are more recent than the specified delay. 
  // The delay is defined in days.
  // See the --older parameter of the CLI.
  int64_t     older;
  // That option defines the maximun rate in msg/s allocated for
  // files/directories deletion.
  // See the --rate parameter of the CLI.
  int32_t     deletion_rate;
  // That option defines the maximun rate in msg/s allocated for inode scanning
  // See the --scan parameter of the CLI.
  int32_t     scan_rate;
  // That option when asserted sets the process in verbose mode
  // See --verbose parameter of the CLI.
  int32_t     verbose;
} trash_process_config_t;

extern trash_process_config_t trash_process_config;

/*_______________________________
** ENUM macro
*/
#endif
