#include <stdio.h>
#include <mpi.h> //Header MPI

int main (int argc, char *argv[]) {
  int nb_procs; 	//Nombre de processus
  int rang; 	//Rang du processus
  char buf[128];
  MPI_Status status;
  int ret;
  MPI_File fhw;

  ret = MPI_Init(&argc,&argv); //Initialisation de l'environnement MPI

  //Verification d'erreur
  if (ret != MPI_SUCCESS)
  {
	  printf("Erreur d'initialisation de MPI\n");
	  return(-1);
  }

  MPI_Comm_size( MPI_COMM_WORLD, &nb_procs ); //Nombre total de processus
  MPI_Comm_rank( MPI_COMM_WORLD, &rang );     //Numero du processus

  int size = sprintf(buf,"hello %3d %3d\n",nb_procs,rang);

  MPI_File_open(MPI_COMM_WORLD, "hello.res", MPI_MODE_CREATE|MPI_MODE_WRONLY, MPI_INFO_NULL, &fhw);
  MPI_File_set_view(fhw, size*rang, MPI_CHAR, MPI_CHAR, "native", MPI_INFO_NULL);
  MPI_File_write(fhw, buf, size, MPI_CHAR, &status);
  MPI_File_close(&fhw);
  MPI_Finalize(); //Cloture de l'environnement MPI

  return 0;
}
